docker-build:
  image:
    name: registry.access.redhat.com/ubi8/buildah:latest
  variables:
    DOCKERBUILD_DIR: '$CI_PROJECT_DIR'
    DOCKERFILE_NAME: 'Dockerfile'
    REGISTRY: $CI_REGISTRY
    REGISTRY_USER: $CI_REGISTRY_USER
    REGISTRY_PASSWORD: $CI_REGISTRY_PASSWORD
    IMAGE_PATH: ''
  before_script:
    - buildah version
  script:
    - |
      if [[ "${CI_COMMIT_BRANCH}" == "${CI_DEFAULT_BRANCH}" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":${CI_COMMIT_REF_SLUG}"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = ${tag}"
      fi
    - |
          if [[ "${REGISTRY}" != "${CI_REGISTRY}" ]]; then
            REGISTRY_IMAGE="${REGISTRY}/${IMAGE_PATH}/${CI_PROJECT_NAME}"
          else
            REGISTRY_IMAGE=${CI_REGISTRY_IMAGE}
          fi    
    - export REGISTRY_AUTH_FILE=${HOME}/auth.json
    - echo "$REGISTRY_PASSWORD" | buildah login -u "$REGISTRY_USER" --password-stdin $REGISTRY # Log into GitLab's container repository.
    - export STORAGE_DRIVER=vfs # Use vfs with buildah. Docker offers overlayfs as a default, but buildah cannot stack overlayfs on top of another overlayfs filesystem.
    - buildah bud -f ${DOCKERBUILD_DIR}/${DOCKERFILE_NAME} -t ${CI_PROJECT_NAME} .
    - CONTAINER_ID=$(buildah from ${CI_PROJECT_NAME})
    - buildah commit --squash $CONTAINER_ID ${REGISTRY_IMAGE}${tag}
    - buildah push ${REGISTRY_IMAGE}${tag}
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile

update_downstream:
  image:
    name: registry.access.redhat.com/ubi8/ubi:latest
  stage: deploy
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - yum install bash jq curl -y
    - bash
    - namespace=$(jq -rn --arg x "$CI_PROJECT_NAMESPACE" '$x|@uri')
    - project=$(curl -s -X GET -H "PRIVATE-TOKEN:${READ_TOKEN}" "${CI_API_V4_URL}/groups/${namespace}/projects" | jq '.[] | select(.path=="buildah-container") | .id')
    - curl --request POST --form "token=$CI_JOB_TOKEN" --form ref=main "${CI_API_V4_URL}/projects/${project}/trigger/pipeline"
